Index: src/language/dictionary/sys-file-info.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/sys-file-info.c,v
retrieving revision 1.10
diff -b -w -U3 -r1.10 sys-file-info.c
--- src/language/dictionary/sys-file-info.c	19 Oct 2006 15:04:53 -0000	1.10
+++ src/language/dictionary/sys-file-info.c	25 Oct 2006 22:52:38 -0000
@@ -78,7 +78,7 @@
 
 /* SYSFILE INFO utility. */
 int
-cmd_sysfile_info (void)
+cmd_sysfile_info (struct dataset *ds UNUSED)
 {
   struct file_handle *h;
   struct dictionary *d;
@@ -176,12 +176,12 @@
 /* DISPLAY utility. */
 
 static void display_macros (void);
-static void display_documents (void);
+static void display_documents (const struct dictionary *dict);
 static void display_variables (struct variable **, size_t, int);
-static void display_vectors (int sorted);
+static void display_vectors (const struct dictionary *dict, int sorted);
 
 int
-cmd_display (void)
+cmd_display (struct dataset *ds)
 {
   /* Whether to sort the list of variables alphabetically. */
   int sorted;
@@ -193,19 +193,19 @@
   if (lex_match_id ("MACROS"))
     display_macros ();
   else if (lex_match_id ("DOCUMENTS"))
-    display_documents ();
+    display_documents (dataset_dict (ds));
   else if (lex_match_id ("FILE"))
     {
       som_blank_line ();
       if (!lex_force_match_id ("LABEL"))
 	return CMD_FAILURE;
-      if (dict_get_label (dataset_dict (current_dataset)) == NULL)
+      if (dict_get_label (dataset_dict (ds)) == NULL)
 	tab_output_text (TAB_LEFT,
 			 _("The active file does not have a file label."));
       else
 	{
 	  tab_output_text (TAB_LEFT | TAT_TITLE, _("File label:"));
-	  tab_output_text (TAB_LEFT | TAB_FIX, dict_get_label (dataset_dict (current_dataset)));
+	  tab_output_text (TAB_LEFT | TAB_FIX, dict_get_label (dataset_dict (ds)));
 	}
     }
   else
@@ -231,7 +231,7 @@
 
       if (as == AS_VECTOR)
 	{
-	  display_vectors (sorted);
+	  display_vectors (dataset_dict(ds), sorted);
 	  return CMD_SUCCESS;
 	}
 
@@ -241,7 +241,7 @@
 
       if (token != '.')
 	{
-	  if (!parse_variables (dataset_dict (current_dataset), &vl, &n, PV_NONE))
+	  if (!parse_variables (dataset_dict (ds), &vl, &n, PV_NONE))
 	    {
 	      free (vl);
 	      return CMD_FAILURE;
@@ -249,7 +249,7 @@
 	  as = AS_DICTIONARY;
 	}
       else
-	dict_get_vars (dataset_dict (current_dataset), &vl, &n, 0);
+	dict_get_vars (dataset_dict (ds), &vl, &n, 0);
 
       if (as == AS_SCRATCH)
 	{
@@ -289,9 +289,9 @@
 }
 
 static void
-display_documents (void)
+display_documents (const struct dictionary *dict)
 {
-  const char *documents = dict_get_documents (dataset_dict (current_dataset));
+  const char *documents = dict_get_documents (dict);
 
   som_blank_line ();
   if (documents == NULL)
@@ -567,14 +567,14 @@
 /* Display a list of vectors.  If SORTED is nonzero then they are
    sorted alphabetically. */
 static void
-display_vectors (int sorted)
+display_vectors (const struct dictionary *dict, int sorted)
 {
   const struct vector **vl;
   int i;
   struct tab_table *t;
   size_t nvec;
   
-  nvec = dict_get_vector_cnt (dataset_dict (current_dataset));
+  nvec = dict_get_vector_cnt (dict);
   if (nvec == 0)
     {
       msg (SW, _("No vectors defined."));
@@ -583,7 +583,7 @@
 
   vl = xnmalloc (nvec, sizeof *vl);
   for (i = 0; i < nvec; i++)
-    vl[i] = dict_get_vector (dataset_dict (current_dataset), i);
+    vl[i] = dict_get_vector (dict, i);
   if (sorted)
     qsort (vl, nvec, sizeof *vl, compare_vectors_by_name);
 
Index: src/language/dictionary/value-labels.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/value-labels.c,v
retrieving revision 1.8
diff -b -w -U3 -r1.8 value-labels.c
--- src/language/dictionary/value-labels.c	19 Oct 2006 15:04:53 -0000	1.8
+++ src/language/dictionary/value-labels.c	25 Oct 2006 22:52:38 -0000
@@ -38,7 +38,7 @@
 
 /* Declarations. */
 
-static int do_value_labels (int);
+static int do_value_labels (const struct dictionary *dict, int);
 static int verify_val_labs (struct variable **vars, size_t var_cnt);
 static void erase_labels (struct variable **vars, size_t var_cnt);
 static int get_label (struct variable **vars, size_t var_cnt);
@@ -46,21 +46,21 @@
 /* Stubs. */
 
 int
-cmd_value_labels (void)
+cmd_value_labels (struct dataset *ds)
 {
-  return do_value_labels (1);
+  return do_value_labels (dataset_dict (ds), 1);
 }
 
 int
-cmd_add_value_labels (void)
+cmd_add_value_labels (struct dataset *ds)
 {
-  return do_value_labels (0);
+  return do_value_labels (dataset_dict (ds), 0);
 }
 
 /* Do it. */
 
 static int
-do_value_labels (int erase)
+do_value_labels (const struct dictionary *dict, int erase)
 {
   struct variable **vars; /* Variable list. */
   size_t var_cnt;         /* Number of variables. */
@@ -70,7 +70,7 @@
   
   while (token != '.')
     {
-      parse_err = !parse_variables (dataset_dict (current_dataset), &vars, &var_cnt, 
+      parse_err = !parse_variables (dict, &vars, &var_cnt, 
 				    PV_SAME_TYPE) ;
       if (var_cnt < 1)
 	{
Index: src/language/dictionary/variable-display.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/variable-display.c,v
retrieving revision 1.8
diff -b -w -U3 -r1.8 variable-display.c
--- src/language/dictionary/variable-display.c	19 Oct 2006 15:04:53 -0000	1.8
+++ src/language/dictionary/variable-display.c	25 Oct 2006 22:52:38 -0000
@@ -36,7 +36,7 @@
    It affects nothing but GUIs
 */
 int
-cmd_variable_alignment (void)
+cmd_variable_alignment (struct dataset *ds)
 {
   do
     {
@@ -46,7 +46,7 @@
       size_t i;
       enum alignment align;
 
-      if (!parse_variables (dataset_dict (current_dataset), &v, &nv, PV_NONE))
+      if (!parse_variables (dataset_dict (ds), &v, &nv, PV_NONE))
         return CMD_FAILURE;
 
       if ( lex_force_match('(') ) 
@@ -89,7 +89,7 @@
    It affects nothing but GUIs
 */
 int
-cmd_variable_width (void)
+cmd_variable_width (struct dataset *ds)
 {
   do
     {
@@ -97,7 +97,7 @@
       size_t nv;
       size_t i;
 
-      if (!parse_variables (dataset_dict (current_dataset), &v, &nv, PV_NONE))
+      if (!parse_variables (dataset_dict (ds), &v, &nv, PV_NONE))
         return CMD_FAILURE;
 
       if ( lex_force_match('(') ) 
@@ -123,7 +123,7 @@
 
 /* Set variables' measurement level */
 int
-cmd_variable_level (void)
+cmd_variable_level (struct dataset *ds)
 {
   do
     {
@@ -132,7 +132,7 @@
       enum measure level;
       size_t i;
 
-      if (!parse_variables (dataset_dict (current_dataset), &v, &nv, PV_NONE))
+      if (!parse_variables (dataset_dict (ds), &v, &nv, PV_NONE))
         return CMD_FAILURE;
 
       if ( lex_force_match('(') ) 
Index: src/language/dictionary/variable-label.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/variable-label.c,v
retrieving revision 1.9
diff -b -w -U3 -r1.9 variable-label.c
--- src/language/dictionary/variable-label.c	19 Oct 2006 15:04:53 -0000	1.9
+++ src/language/dictionary/variable-label.c	25 Oct 2006 22:52:38 -0000
@@ -35,7 +35,7 @@
 #define _(msgid) gettext (msgid)
 
 int
-cmd_variable_labels (void)
+cmd_variable_labels (struct dataset *ds)
 {
   do
     {
@@ -44,7 +44,7 @@
 
       size_t i;
 
-      if (!parse_variables (dataset_dict (current_dataset), &v, &nv, PV_NONE))
+      if (!parse_variables (dataset_dict (ds), &v, &nv, PV_NONE))
         return CMD_FAILURE;
 
       if (token != T_STRING)
Index: src/language/dictionary/vector.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/vector.c,v
retrieving revision 1.8
diff -b -w -U3 -r1.8 vector.c
--- src/language/dictionary/vector.c	19 Oct 2006 15:04:53 -0000	1.8
+++ src/language/dictionary/vector.c	25 Oct 2006 22:52:38 -0000
@@ -37,7 +37,7 @@
 #define _(msgid) gettext (msgid)
 
 int
-cmd_vector (void)
+cmd_vector (struct dataset *ds)
 {
   /* Just to be different, points to a set of null terminated strings
      containing the names of the vectors to be created.  The list
@@ -51,6 +51,8 @@
   /* Maximum allocated position for vecnames, plus one position. */
   char *endp = NULL;
 
+  struct dictionary *dict = dataset_dict (ds);
+
   cp = vecnames = xmalloc (256);
   endp = &vecnames[256];
   do
@@ -75,7 +77,7 @@
 		goto fail;
 	      }
 
-	  if (dict_lookup_vector (dataset_dict (current_dataset), tokid))
+	  if (dict_lookup_vector (dict, tokid))
 	    {
 	      msg (SE, _("There is already a vector with name %s."), tokid);
 	      goto fail;
@@ -104,11 +106,11 @@
 	      goto fail;
 	    }
 
-	  if (!parse_variables (dataset_dict (current_dataset), &v, &nv,
+	  if (!parse_variables (dict, &v, &nv,
                                 PV_SAME_TYPE | PV_DUPLICATE))
 	    goto fail;
 
-          dict_create_vector (dataset_dict (current_dataset), vecnames, v, nv);
+          dict_create_vector (dict, vecnames, v, nv);
           free (v);
 	}
       else if (lex_match ('('))
@@ -158,7 +160,7 @@
 	      for (i = 0; i < nv; i++)
 		{
 		  sprintf (name, "%s%d", cp, i + 1);
-		  if (dict_lookup_var (dataset_dict (current_dataset), name))
+		  if (dict_lookup_var (dict, name))
 		    {
 		      msg (SE, _("There is already a variable named %s."),
                            name);
@@ -175,9 +177,9 @@
 	      for (i = 0; i < nv; i++)
 		{
 		  sprintf (name, "%s%d", cp, i + 1);
-		  v[i] = dict_create_var_assert (dataset_dict (current_dataset), name, 0);
+		  v[i] = dict_create_var_assert (dict, name, 0);
 		}
-              if (!dict_create_vector (dataset_dict (current_dataset), cp, v, nv))
+              if (!dict_create_vector (dict, cp, v, nv))
                 NOT_REACHED ();
 	      cp += strlen (cp) + 1;
 	    }
Index: src/language/dictionary/weight.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/dictionary/weight.c,v
retrieving revision 1.6
diff -b -w -U3 -r1.6 weight.c
--- src/language/dictionary/weight.c	19 Oct 2006 15:04:53 -0000	1.6
+++ src/language/dictionary/weight.c	25 Oct 2006 22:52:38 -0000
@@ -34,16 +34,17 @@
 #define _(msgid) gettext (msgid)
 
 int
-cmd_weight (void)
+cmd_weight (struct dataset *ds)
 {
+  struct dictionary *dict = dataset_dict (ds);
   if (lex_match_id ("OFF"))
-    dict_set_weight (dataset_dict (current_dataset), NULL);
+    dict_set_weight (dataset_dict (ds), NULL);
   else
     {
       struct variable *v;
 
       lex_match (T_BY);
-      v = parse_variable ();
+      v = parse_dict_variable (dict);
       if (!v)
 	return CMD_CASCADING_FAILURE;
       if (v->type == ALPHA)
@@ -57,7 +58,7 @@
 	  return CMD_CASCADING_FAILURE;
 	}
 
-      dict_set_weight (dataset_dict (current_dataset), v);
+      dict_set_weight (dict, v);
     }
 
   return lex_end_of_command ();
Index: src/language/expressions/evaluate.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/expressions/evaluate.c,v
retrieving revision 1.7
diff -b -w -U3 -r1.7 evaluate.c
--- src/language/expressions/evaluate.c	14 Jul 2006 02:28:29 -0000	1.7
+++ src/language/expressions/evaluate.c	25 Oct 2006 22:52:38 -0000
@@ -32,12 +32,15 @@
 expr_evaluate (struct expression *e, const struct ccase *c, int case_idx,
                void *result)
 {
+  struct dataset *ds = e->ds;
   union operation_data *op = e->ops;
 
   double *ns = e->number_stack;
   struct substring *ss = e->string_stack;
 
-  assert ((c != NULL) == (e->dict != NULL));
+#if 0
+  assert ((c != NULL) == (dataset_dict (e->ds) != NULL));
+#endif
   pool_clear (e->eval_pool);
 
   for (;;)
@@ -102,18 +105,21 @@
 #include <language/command.h>
 
 int
-cmd_debug_evaluate (void)
+cmd_debug_evaluate (struct dataset *dsother UNUSED)
 {
   bool optimize = true;
   int retval = CMD_FAILURE;
   bool dump_postfix = false;
-  struct dictionary *d = NULL;
+
   struct ccase *c = NULL;
 
+  struct dataset *ds = NULL;
+
   struct expression *expr;
 
   for (;;) 
     {
+      struct dictionary *d = NULL;
       if (lex_match_id ("NOOPTIMIZE"))
         optimize = 0;
       else if (lex_match_id ("POSTFIX"))
@@ -149,8 +155,11 @@
               goto done;
             }
 
-          if (d == NULL)
-            d = dict_create ();
+	  if  ( ds == NULL ) 
+	    {
+	      ds = create_dataset ();
+	      d = dataset_dict (ds);
+	    }
           
           old_value_cnt = dict_get_next_value_idx (d);
           v = dict_create_var (d, name, width);
@@ -186,12 +195,13 @@
       lex_force_match ('/');
       goto done;
     }
-  if (d != NULL)
+
+  if ( ds != NULL ) 
     fprintf (stderr, "; ");
   fprintf (stderr, "%s => ", lex_rest_of_line (NULL));
   lex_get ();
 
-  expr = expr_parse_any (d, optimize);
+  expr = expr_parse_any (ds, optimize);
   if (!expr || lex_end_of_command () != CMD_SUCCESS)
     {
       if (expr != NULL)
@@ -247,7 +257,7 @@
       case_destroy (c);
       free (c); 
     }
-  dict_destroy (d);
+
   return retval;
 }
 
Index: src/language/expressions/generate.pl
===================================================================
RCS file: /sources/pspp/pspp/src/language/expressions/generate.pl,v
retrieving revision 1.3
diff -b -w -U3 -r1.3 generate.pl
--- src/language/expressions/generate.pl	9 Jun 2006 22:51:24 -0000	1.3
+++ src/language/expressions/generate.pl	25 Oct 2006 22:52:38 -0000
@@ -111,6 +111,8 @@
 	       FIXED_VALUE => 'c');
     init_type ('case_idx', 'fixed', C_TYPE => 'size_t',
 	       FIXED_VALUE => 'case_idx');
+    init_type ('dataset', 'fixed', C_TYPE => 'struct dataset *',
+	       FIXED_VALUE => 'ds');
 
     # One of these is emitted at the end of each expression as a sentinel
     # that tells expr_evaluate() to return the value on the stack.
Index: src/language/expressions/operations.def
===================================================================
RCS file: /sources/pspp/pspp/src/language/expressions/operations.def,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 operations.def
--- src/language/expressions/operations.def	19 Oct 2006 15:04:53 -0000	1.5
+++ src/language/expressions/operations.def	25 Oct 2006 22:52:38 -0000
@@ -957,8 +957,9 @@
 }
 
 no_opt perm_only function LAG (num_var v, pos_int n_before)
+    dataset ds;
 {
-  struct ccase *c = lagged_case (current_dataset, n_before);
+  struct ccase *c = lagged_case (ds, n_before);
   if (c != NULL)
     {
       double x = case_num (c, v->fv);
@@ -969,8 +970,9 @@
 }
 
 no_opt perm_only function LAG (num_var v)
+    dataset ds;
 {
-  struct ccase *c = lagged_case (current_dataset, 1);
+  struct ccase *c = lagged_case (ds, 1);
   if (c != NULL)
     {
       double x = case_num (c, v->fv);
@@ -982,8 +984,9 @@
 
 no_opt perm_only string function LAG (str_var v, pos_int n_before)
      expression e;
+     dataset ds;
 {
-  struct ccase *c = lagged_case (current_dataset, n_before);
+  struct ccase *c = lagged_case (ds, n_before);
   if (c != NULL)
     return copy_string (e, case_str (c, v->fv), v->width);
   else
@@ -992,8 +995,9 @@
 
 no_opt perm_only string function LAG (str_var v)
      expression e;
+     dataset ds;
 {
-  struct ccase *c = lagged_case (current_dataset, 1);
+  struct ccase *c = lagged_case (ds, 1);
   if (c != NULL)
     return copy_string (e, case_str (c, v->fv), v->width);
   else
Index: src/language/expressions/parse.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/expressions/parse.c,v
retrieving revision 1.15
diff -b -w -U3 -r1.15 parse.c
--- src/language/expressions/parse.c	20 Oct 2006 11:32:57 -0000	1.15
+++ src/language/expressions/parse.c	25 Oct 2006 22:52:39 -0000
@@ -50,7 +50,7 @@
 static parse_recursively_func parse_vector_element, parse_function;
 
 /* Utility functions. */
-static struct expression *expr_create (struct dictionary *);
+static struct expression *expr_create (struct dataset *ds);
 atom_type expr_node_returns (const union any_node *);
 
 static const char *atom_type_name (atom_type);
@@ -70,14 +70,14 @@
    Returns the new expression if successful or a null pointer
    otherwise. */
 struct expression *
-expr_parse (struct dictionary *dict, enum expr_type type) 
+expr_parse (struct dataset *ds, enum expr_type type) 
 {
   union any_node *n;
   struct expression *e;
 
   assert (type == EXPR_NUMBER || type == EXPR_STRING || type == EXPR_BOOLEAN);
 
-  e = expr_create (dict);
+  e = expr_create (ds);
   n = parse_or (e);
   if (n != NULL && type_check (e, &n, type))
     return finish_expression (expr_optimize (n, e), e);
@@ -93,9 +93,10 @@
    the expression as well. */
 struct expression *
 expr_parse_pool (struct pool *pool,
-                 struct dictionary *dict, enum expr_type type) 
+		 struct dataset *ds, 
+                 enum expr_type type) 
 {
-  struct expression *e = expr_parse (dict, type);
+  struct expression *e = expr_parse (ds, type);
   if (e != NULL)
     pool_add_subpool (pool, e->expr_pool);
   return e;
@@ -110,12 +111,12 @@
 }
 
 struct expression *
-expr_parse_any (struct dictionary *dict, bool optimize)
+expr_parse_any (struct dataset *ds, bool optimize)
 {
   union any_node *n;
   struct expression *e;
 
-  e = expr_create (dict);
+  e = expr_create (ds);
   n = parse_or (e);
   if (n == NULL)
     {
@@ -733,7 +734,7 @@
           "JUL", "AUG", "SEP", "OCT", "NOV", "DEC",
         };
 
-      time_t last_proc_time = time_of_last_procedure (current_dataset);
+      time_t last_proc_time = time_of_last_procedure (e->ds);
       struct tm *time;
       char temp_buf[10];
 
@@ -751,7 +752,7 @@
     return expr_allocate_number (e, SYSMIS);
   else if (lex_match_id ("$JDATE"))
     {
-      time_t time = time_of_last_procedure (current_dataset);
+      time_t time = time_of_last_procedure (e->ds);
       struct tm *tm = localtime (&time);
       return expr_allocate_number (e, expr_ymd_to_ofs (tm->tm_year + 1900,
                                                        tm->tm_mon + 1,
@@ -759,7 +760,7 @@
     }
   else if (lex_match_id ("$TIME"))
     {
-      time_t time = time_of_last_procedure (current_dataset);
+      time_t time = time_of_last_procedure (e->ds);
       struct tm *tm = localtime (&time);
       return expr_allocate_number (e,
                                    expr_ymd_to_date (tm->tm_year + 1900,
@@ -792,7 +793,7 @@
           /* An identifier followed by a left parenthesis may be
              a vector element reference.  If not, it's a function
              call. */
-          if (e->dict != NULL && dict_lookup_vector (e->dict, tokid) != NULL) 
+          if (e->ds != NULL && dict_lookup_vector (dataset_dict (e->ds), tokid) != NULL) 
             return parse_vector_element (e);
           else
             return parse_function (e);
@@ -802,12 +803,12 @@
           /* $ at the beginning indicates a system variable. */
           return parse_sysvar (e);
         }
-      else if (e->dict != NULL && dict_lookup_var (e->dict, tokid))
+      else if (e->ds != NULL && dict_lookup_var (dataset_dict (e->ds), tokid))
         {
           /* It looks like a user variable.
              (It could be a format specifier, but we'll assume
              it's a variable unless proven otherwise. */
-          return allocate_unary_variable (e, parse_dict_variable (e->dict));
+          return allocate_unary_variable (e, parse_dict_variable (dataset_dict (e->ds)));
         }
       else 
         {
@@ -872,7 +873,7 @@
   /* Find vector, skip token.
      The caller must already have verified that the current token
      is the name of a vector. */
-  vector = dict_lookup_vector (dataset_dict (current_dataset), tokid);
+  vector = dict_lookup_vector (dataset_dict (e->ds), tokid);
   assert (vector != NULL);
   lex_get ();
 
@@ -1185,7 +1186,7 @@
             size_t var_cnt;
             size_t i;
 
-            if (!parse_variables (dataset_dict (current_dataset), &vars, &var_cnt, PV_SINGLE))
+            if (!parse_variables (dataset_dict (e->ds), &vars, &var_cnt, PV_SINGLE))
               goto fail;
             for (i = 0; i < var_cnt; i++)
               add_arg (&args, &arg_cnt, &arg_cap,
@@ -1231,7 +1232,7 @@
       goto fail;
     }
   if ((f->flags & OPF_PERM_ONLY) && 
-      proc_in_temporary_transformations (current_dataset)) 
+      proc_in_temporary_transformations (e->ds)) 
     {
       msg (SE, _("%s may not appear after TEMPORARY."), f->prototype);
       goto fail;
@@ -1242,8 +1243,8 @@
 
   if (n->type == OP_LAG_Vn || n->type == OP_LAG_Vs) 
     {
-      if (dataset_n_lag (current_dataset) < 1)
-        dataset_set_n_lag (current_dataset, 1);
+      if (dataset_n_lag (e->ds) < 1)
+        dataset_set_n_lag (e->ds, 1);
     }
   else if (n->type == OP_LAG_Vnn || n->type == OP_LAG_Vsn)
     {
@@ -1251,8 +1252,8 @@
       assert (n->composite.arg_cnt == 2);
       assert (n->composite.args[1]->type == OP_pos_int);
       n_before = n->composite.args[1]->integer.i;
-      if ( dataset_n_lag (current_dataset) < n_before)
-        dataset_set_n_lag (current_dataset, n_before);
+      if ( dataset_n_lag (e->ds) < n_before)
+        dataset_set_n_lag (e->ds, n_before);
     }
   
   free (args);
@@ -1268,12 +1269,12 @@
 /* Utility functions. */
 
 static struct expression *
-expr_create (struct dictionary *dict)
+expr_create (struct dataset *ds)
 {
   struct pool *pool = pool_create ();
   struct expression *e = pool_alloc (pool, sizeof *e);
   e->expr_pool = pool;
-  e->dict = dict;
+  e->ds = ds;
   e->eval_pool = pool_create_subpool (e->expr_pool);
   e->ops = NULL;
   e->op_types = NULL;
Index: src/language/expressions/private.h
===================================================================
RCS file: /sources/pspp/pspp/src/language/expressions/private.h,v
retrieving revision 1.5
diff -b -w -U3 -r1.5 private.h
--- src/language/expressions/private.h	20 Oct 2006 11:32:57 -0000	1.5
+++ src/language/expressions/private.h	25 Oct 2006 22:52:39 -0000
@@ -156,7 +156,7 @@
 struct expression
   {
     struct pool *expr_pool;     /* Pool for expression static data. */
-    struct dictionary *dict;    /* Dictionary for variables, vectors. */
+    struct dataset *ds ;        /* The dataset */
     atom_type type;             /* Type of expression result. */
 
     union operation_data *ops;  /* Expression data. */
@@ -168,7 +168,7 @@
     struct pool *eval_pool;     /* Pool for evaluation temporaries. */
   };
 
-struct expression *expr_parse_any (struct dictionary *, bool optimize);
+struct expression *expr_parse_any (struct dataset *,  bool optimize);
 void expr_debug_print_postfix (const struct expression *);
 
 union any_node *expr_optimize (union any_node *, struct expression *);
Index: src/language/expressions/public.h
===================================================================
RCS file: /sources/pspp/pspp/src/language/expressions/public.h,v
retrieving revision 1.1
diff -b -w -U3 -r1.1 public.h
--- src/language/expressions/public.h	4 Mar 2006 01:11:57 -0000	1.1
+++ src/language/expressions/public.h	25 Oct 2006 22:52:39 -0000
@@ -35,12 +35,15 @@
 struct ccase;
 struct pool;
 union value;
+struct dataset ;
 
-struct expression *expr_parse (struct dictionary *, enum expr_type);
+struct expression *expr_parse (struct dataset *, enum expr_type);
 struct expression *expr_parse_pool (struct pool *,
-                                    struct dictionary *, enum expr_type);
+				    struct dataset *,
+                                    enum expr_type);
 void expr_free (struct expression *);
 
+struct dataset;
 double expr_evaluate_num (struct expression *, const struct ccase *,
                           int case_idx);
 void expr_evaluate_str (struct expression *, const struct ccase *,
Index: src/language/lexer/q2c.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/lexer/q2c.c,v
retrieving revision 1.16
diff -b -w -U3 -r1.16 q2c.c
--- src/language/lexer/q2c.c	19 Oct 2006 15:04:53 -0000	1.16
+++ src/language/lexer/q2c.c	25 Oct 2006 22:52:39 -0000
@@ -1177,7 +1177,7 @@
 	      dump (0, "/* Prototype for custom subcommands of %s. */",
 		    cmdname);
 	    }
-	  dump (0, "static int %scustom_%s (struct cmd_%s *, void *);",
+	  dump (0, "static int %scustom_%s (struct dataset *, struct cmd_%s *, void *);",
 		st_lower (prefix), st_lower (sbc->name),
 		make_identifier (cmdname));
 	}
@@ -1189,7 +1189,7 @@
   /* Prototypes for parsing and freeing functions. */
   {
     dump (0, "/* Command parsing functions. */");
-    dump (0, "static int parse_%s (struct cmd_%s *, void *);",
+    dump (0, "static int parse_%s (struct dataset *, struct cmd_%s *, void *);",
 	  make_identifier (cmdname), make_identifier (cmdname));
     dump (0, "static void free_%s (struct cmd_%s *);",
 	  make_identifier (cmdname), make_identifier (cmdname));
@@ -1584,7 +1584,7 @@
     }
   else if (sbc->type == SBC_VARLIST)
     {
-      dump (1, "if (!parse_variables (dataset_dict (current_dataset), &p->%sv_%s, &p->%sn_%s, "
+      dump (1, "if (!parse_variables (dataset_dict (ds), &p->%sv_%s, &p->%sn_%s, "
 	    "PV_APPEND%s%s))",
 	    st_lower (sbc->prefix), st_lower (sbc->name),
 	    st_lower (sbc->prefix), st_lower (sbc->name),
@@ -1595,7 +1595,7 @@
     }
   else if (sbc->type == SBC_VAR)
     {
-      dump (0, "p->%sv_%s = parse_variable ();",
+      dump (0, "p->%sv_%s = parse_dict_variable (dataset_dict (ds));",
 	    st_lower (sbc->prefix), st_lower (sbc->name));
       dump (1, "if (!p->%sv_%s)",
 	    st_lower (sbc->prefix), st_lower (sbc->name));
@@ -1696,7 +1696,7 @@
     }
   else if (sbc->type == SBC_CUSTOM)
     {
-      dump (1, "switch (%scustom_%s (p, aux))",
+      dump (1, "switch (%scustom_%s (ds, p, aux))",
 	    st_lower (prefix), st_lower (sbc->name));
       dump (0, "{");
       dump (1, "case 0:");
@@ -1725,8 +1725,9 @@
   indent = 0;
 
   dump (0, "static int");
-  dump (0, "parse_%s (struct cmd_%s *p, void *aux UNUSED)",
+  dump (0, "parse_%s (struct dataset *ds%s, struct cmd_%s *p, void *aux UNUSED)",
         make_identifier (cmdname),
+	(def && ( def->type == SBC_VARLIST && def->type == SBC_CUSTOM))?"":" UNUSED",
 	make_identifier (cmdname));
   dump (1, "{");
 
@@ -1740,18 +1741,18 @@
     {
       if (def->type == SBC_VARLIST)
 	dump (1, "if (token == T_ID "
-              "&& dict_lookup_var (dataset_dict (current_dataset), tokid) != NULL "
+              "&& dict_lookup_var (dataset_dict (ds), tokid) != NULL "
 	      "&& lex_look_ahead () != '=')");
       else
 	{
 	  dump (0, "if ((token == T_ID "
-                "&& dict_lookup_var (dataset_dict (current_dataset), tokid) "
+                "&& dict_lookup_var (dataset_dict (ds), tokid) "
 		"&& lex_look_ahead () != '=')");
 	  dump (1, "     || token == T_ALL)");
 	}
       dump (1, "{");
       dump (0, "p->sbc_%s++;", st_lower (def->name));
-      dump (1, "if (!parse_variables (dataset_dict (current_dataset), &p->%sv_%s, &p->%sn_%s, "
+      dump (1, "if (!parse_variables (dataset_dict (ds), &p->%sv_%s, &p->%sn_%s, "
 	    "PV_APPEND))",
 	    st_lower (def->prefix), st_lower (def->name),
 	    st_lower (def->prefix), st_lower (def->name));
@@ -1762,7 +1763,7 @@
     }
   else if (def && def->type == SBC_CUSTOM)
     {
-      dump (1, "switch (%scustom_%s (p, aux))",
+      dump (1, "switch (%scustom_%s (ds, p, aux))",
 	    st_lower (prefix), st_lower (def->name));
       dump (0, "{");
       dump (1, "case 0:");
@@ -2063,7 +2064,5 @@
       dump (0, "#line %d \"%s\"", ln + 1, ifn);
     }
 
-
-
   return EXIT_SUCCESS;
 }
Index: src/language/lexer/variable-parser.c
===================================================================
RCS file: /sources/pspp/pspp/src/language/lexer/variable-parser.c,v
retrieving revision 1.9
diff -b -w -U3 -r1.9 variable-parser.c
--- src/language/lexer/variable-parser.c	19 Oct 2006 15:04:53 -0000	1.9
+++ src/language/lexer/variable-parser.c	25 Oct 2006 22:52:39 -0000
@@ -87,16 +87,6 @@
   return var;
 }
 
-/* Parses a variable name in dataset_dict (current_dataset) and returns the
-   variable if successful.  On failure emits an error message and
-   returns a null pointer. */
-struct variable *
-parse_variable (void)
-{
-  return parse_dict_variable (dataset_dict (current_dataset));
-}
-
-
 /* Parses a set of variables from dictionary D given options
    OPTS.  Resulting list of variables stored in *VAR and the
    number of variables into *CNT.  Returns true only if
@@ -533,7 +523,8 @@
    existing and the rest are to be created.  Same args as
    parse_DATA_LIST_vars(). */
 bool
-parse_mixed_vars (char ***names, size_t *nnames, int pv_opts)
+parse_mixed_vars (const struct dictionary *dict, 
+		  char ***names, size_t *nnames, int pv_opts)
 {
   size_t i;
 
@@ -548,12 +539,12 @@
     }
   while (token == T_ID || token == T_ALL)
     {
-      if (token == T_ALL || dict_lookup_var (dataset_dict (current_dataset), tokid) != NULL)
+      if (token == T_ALL || dict_lookup_var (dict, tokid) != NULL)
 	{
 	  struct variable **v;
 	  size_t nv;
 
-	  if (!parse_variables (dataset_dict (current_dataset), &v, &nv, PV_NONE))
+	  if (!parse_variables (dict, &v, &nv, PV_NONE))
 	    goto fail;
 	  *names = xnrealloc (*names, *nnames + nv, sizeof **names);
 	  for (i = 0; i < nv; i++)
@@ -580,7 +571,7 @@
    parse_mixed_vars(), except that all allocations are taken
    from the given POOL. */
 bool
-parse_mixed_vars_pool (struct pool *pool,
+parse_mixed_vars_pool (const struct dictionary *dict, struct pool *pool,
                        char ***names, size_t *nnames, int pv_opts)
 {
   int retval;
@@ -591,7 +582,7 @@
      re-free it later. */
   assert (!(pv_opts & PV_APPEND));
 
-  retval = parse_mixed_vars (names, nnames, pv_opts);
+  retval = parse_mixed_vars (dict, names, nnames, pv_opts);
   if (retval)
     register_vars_pool (pool, *names, *nnames);
   return retval;
Index: src/language/lexer/variable-parser.h
===================================================================
RCS file: /sources/pspp/pspp/src/language/lexer/variable-parser.h,v
retrieving revision 1.3
diff -b -w -U3 -r1.3 variable-parser.h
--- src/language/lexer/variable-parser.h	14 Oct 2006 00:25:20 -0000	1.3
+++ src/language/lexer/variable-parser.h	25 Oct 2006 22:52:39 -0000
@@ -55,7 +55,6 @@
     PV_NO_SCRATCH = 00200 	/* Disallow scratch variables. */
   };
 
-struct variable *parse_variable (void);
 struct variable *parse_dict_variable (const struct dictionary *);
 bool parse_variables (const struct dictionary *, struct variable ***, size_t *,
                      int opts);
@@ -66,8 +65,10 @@
 bool parse_DATA_LIST_vars (char ***names, size_t *cnt, int opts);
 bool parse_DATA_LIST_vars_pool (struct pool *,
                                char ***names, size_t *cnt, int opts);
-bool parse_mixed_vars (char ***names, size_t *cnt, int opts);
-bool parse_mixed_vars_pool (struct pool *,
+bool parse_mixed_vars (const struct dictionary *dict, 
+		       char ***names, size_t *cnt, int opts);
+bool parse_mixed_vars_pool (const struct dictionary *dict, 
+			    struct pool *,
                            char ***names, size_t *cnt, int opts);
 
 #endif /* variable-parser.h */
